# Filename input plugin for Embulk


## Overview

* **Plugin type**: input
* **Resume supported**: not yet
* **Cleanup supported**: yes
* **Guess supported**: no

## Configuration

- **multi_dir**: description (ArrayList<String>, required)
- **mulit_tag**: description (ArrayList<String>, default: `[]`)
- **order_by_modified_time**: description (int, default: `0`)
- **order_by_creation_time**: description (int, default: `0`)
- **chunk_size**: description (int, default: `10485760(10M)`)

## Example

```yaml
exec:
  min_output_tasks: 1
in:
  type: filename 
  mulit_dir: ["../sample/sample_","../example/example_"]
  multi_tag: ["tag1","tag2"]
  order_by_modified_time: 1
  chunk_size: 1000
```
Attention:
exec:
  min_output_tasks: 1
is necessary! 
Embulk will optimize the task according the core number which means that, it will re-distribute the task, which will cause 
errors.

If the multi_dir contains more than one directory. each directory will be treated as a task. the embulk will distribute those tasks to multi 
thread. As each task will one consistently, the files in each directory will be uploading in order.
For example the upload order maybe:
example1.txt
sample1.txt
sample2.txt
example2.txt
sample3.txt

To also upload the directory one by one, you need to configure the max_thread: 1
then you will get
example1.txt
example2.txt
sample1.txt
sample2.txt
sample3.txt



For the order_by_modified_time option, its default value is 0, the files in each directory are uploaded in alphabetical order.
If it equals 1, the files in each directory will be uploaded in the order of their last modified time. 
if it equals neither 1 or 0, the files will be uploaded in descend order of their last modified time.
The order_by_modified_time is the same like order_by_modified_time. Those two option could not be set at same time since the you have to choose 
only one order to upload the files. And the order_by_creation_time is useless in Unix system as the unix system does not record the creation 
time of the files. Use the order_by_creation_time sparingly.


## Build
java 1.8 is required.

```
$ ./gradlew gem  # -t to watch change of files and rebuild continuously
```
